<template>
  <div class="layer-status-control custom-control custom-switch py-1">
    <input type="checkbox" class="custom-control-input" :id="layerId" v-model="model">
    <label class="custom-control-label layer-control-label" :for="layerId">
      <i v-bind:class="icon" class="px-1" :title="layer.title"></i>
      <template v-if="!noText">{{ layer.title }}</template>
    </label>
  </div>
</template>

<script>
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import { SET_WORKSPACE_LAYER_STATUS } from '@/workspace/store/mutations'

export default {
  name: 'layerstatuscontrol',

  mixins: [
    WorkspaceGetter,
  ],

  props: {
    layerId: {
      type: String,
      required: true,
    }
  },

  computed: {
    layer: {
      get() {
        return this.$store.getters.workspaceLayerById(this.workspaceId, this.layerId)
      },
    },

    icon: {
      get() {
        let d = {}
        d['wi ' + this.layer.icon] = true
        return d
      }
    },

    model: {
      get() {
        return this.layer.status
      },

      set(value) {
        this.$store.commit(SET_WORKSPACE_LAYER_STATUS, {
          workspaceId: this.workspaceId,
          layerId: this.layerId,
          value: value,
        })
      },
    },

    noText: {
      get() {
        return this.$store.getters.workspaceLayersPanelMinimized(this.workspaceId)
      }
    }
  },
}
</script>

<style scoped>
.layer-control-label {
  line-height: 1.5rem;
}
</style>
